Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 384 by niro, Mon Jul 17 20:44:44 2006 UTC revision 1616 by niro, Mon Jan 9 20:11:08 2012 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.43 2006-07-17 20:44:44 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  PKGSUFFIX="mpk"  : ${MAGERC="/etc/mage.rc"}
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 ## only for tests -> normally in /etc/rc.d/init.d/functions  
 COLRED="\033[1;6m\033[31m"  
 COLGREEN="\033[1;6m\033[32m"  
 COLYELLOW="\033[1;6m\033[33m"  
 COLBLUE="\033[1;6m\033[34m"  
 COLMAGENTA="\033[1;6m\033[35m"  
 COLWHITE="\033[1;6m\033[37m"  
 COLGRAY="\033[0;6m\033[37m"  
 COLBOLD="\033[1m"  
 COLDEFAULT="\033[0m"  
   
 if [[ ${NOCOLORS} = true ]]  
 then  
  COLRED=""  
  COLGREEN=""  
  COLYELLOW=""  
  COLBLUE=""  
  COLMAGENTA=""  
  COLWHITE=""  
  COLGRAY=""  
  COLBOLD=""  
  COLDEFAULT=""  
 fi  
12    
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc  source /etc/mage.rc.global
17    source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    
20    ## setup ##
21    SMAGENAME="$1"
22    SMAGEVERSION="$(< ${MLIBDIR}/version)"
23    
24  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
25  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
# Line 54  then Line 29  then
29   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
30  fi  fi
31    
32    # sources the smage file and uses state from distribution file if exist
33    # may helpful for repository support later on
34    smagesource()
35    {
36     local file="$1"
37     local mystate
38     local mycodename
39    
40     source ${file}
41    
42     [[ -n ${STATE} ]] && mystate="${STATE}"
43    
44     # do not overide if local state was broken or disabled!
45     case ${STATE} in
46     broken) return ;;
47     disabled) return ;;
48     esac
49    
50     if [ -f ${SMAGESCRIPTSDIR}/distribution ]
51     then
52     source ${SMAGESCRIPTSDIR}/distribution
53     [[ -n ${STATE} ]] && mystate="${STATE}"
54     fi
55     # now switch state and export it
56     STATE="${mystate}"
57    }
58    
59  showversion()  showversion()
60  {  {
61   echo -en "Magellan Source Install v${SMAGEVERSION} "   echo -en "Magellan Source Install v${SMAGEVERSION} "
# Line 63  showversion() Line 65  showversion()
65  die()  die()
66  {  {
67   xtitleclean   xtitleclean
68     echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}
69   echo "SMAGE failed: $@"   echo "SMAGE failed: $@"
70   exit 1   exit 1
71  }  }
72    
73    die_pipestatus()
74    {
75     # the status change if we do any parameter declarations!!
76     # dont do this anymore, keep this in mind!
77     #
78     # local pos="$1"
79     # local comment="$2"
80     #
81     # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
82     #
83     [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
84    }
85    
86  xtitle()  xtitle()
87  {  {
88   if [[ ${TERM} = xterm ]]   if [[ ${TERM} = xterm ]]
# Line 91  syncsmage2() Line 107  syncsmage2()
107   local i   local i
108   for i in ${SMAGE2RSYNC}   for i in ${SMAGE2RSYNC}
109   do   do
110   rsync \   rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
111   if [[ $? = 0 ]]   if [[ $? = 0 ]]
112   then   then
113   break   break
114   else   else
115   continue   continue
116   fi   fi
   
117   done   done
118    
119   # clean up backup files (foo~)   # clean up backup files (foo~)
# Line 138  get_db_md5_sum() Line 139  get_db_md5_sum()
139    
140  download_sources()  download_sources()
141  {  {
   
142   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
143    
144   local EOA=${#SRC_URI[*]}   local count=${#SRC_URI[*]}
145   local my_SRC_URI   local uri
146   local my_SRC_URI_DEST   local subdir
147   local my_SRC_URI_MIRROR   local outputdir
148   local my_SOURCEDIR   local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
149   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   local fetching
150   local FETCHING   local i
  local i mirror  
   
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
151    
152   # check if FETCHING is needed   # check if FETCHING is needed
153   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )   if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
  if [[ $? = 0 ]]  
154   then   then
155   # md5's ok, not fetching needed   # md5's ok, no fetching needed
156   FETCHING=false   fetching=false
157   else   else
158   FETCHING=true   fetching=true
159   fi   fi
160    
161   for ((i=0; i < EOA; i++))   if [[ ${fetching} = true ]]
162   do   then
163   # url to file   for ((i=0; i < count; i++))
164   my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"   do
165     # url to file
166   # subdir in sources dir; the my_SRCI_URI file goes to there   uri="${SRC_URI[${i}]%%' '*}"
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
167    
168   # if an mirrored file than replace first the mirror uri   # subdir in sources dir; the my_SRCI_URI file goes to there
169   if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]   subdir="${SRC_URI[${i}]##*' '}"
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
170    
171   if [[ ${FETCHING} = true ]]   # if $subdir is not equal with $uri then an other dir is used
172   then   if [[ ${uri} != ${subdir} ]]
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
173   then   then
174   echo "==> fetching ${my_SRC_URI}"   outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
175   wget \   else
176   --passive-ftp \   outputdir="${SOURCEDIR}/${PNAME}"
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
177   fi   fi
  fi  
178    
179   # unset them to be shure   echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
180   unset my_SRC_URI   # do not die here, mchecksum catches download errors
181   unset my_SRC_URI_DEST   mdownload --uri "${uri}" --dir "${outputdir}"
182   unset my_SRC_URI_MIRROR  
183   unset my_SOURCEDIR   # unset them to be sure
184   done   unset uri
185     unset subdir
186     unset outputdir
187     done
188    
189   # recheck md5 sums   # recheck md5 sums after download
190   echo   echo
191   echo ">== Checking MD5 sums:"   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
192   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
193   echo   echo
194     else
195     echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
196     fi
197    
198   # not needed anymore   # not needed anymore
199   unset SRC_URI   unset SRC_URI
200  }  }
201    
202  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
203  src_prepare()  src_prepare()
204  {  {
205   echo "no src_prepare defined"   echo "no src_prepare defined; doing nothing ..."
  sleep 2  
206   return 0   return 0
207  }  }
208    
209  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
210  src_compile()  src_compile()
211  {  {
212   echo "no src_compile defined"   echo "no src_compile defined; doing nothing ..."
  sleep 2  
213   return 0   return 0
214  }  }
215    
216  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
217    src_check()
218    {
219     echo "no src_check defined; doing nothing ..."
220     return 0
221    }
222    
223    # dummy function, used if that does not exist in smage file
224  src_install()  src_install()
225  {  {
226   echo "no src_install defined"   echo "no src_install defined; doing nothing ..."
  sleep 2  
227   return 0   return 0
228  }  }
229    
# Line 270  mlibdir() Line 237  mlibdir()
237    
238  mconfigure()  mconfigure()
239  {  {
240     local myopts
241     if [[ ! -z ${CTARGET} ]]
242     then
243     myopts="--target=${CTARGET}"
244     fi
245    
246   if [ -x ./configure ]   if [ -x ./configure ]
247   then   then
248   ./configure \   ./configure \
249   --prefix=/usr \   --prefix=/usr \
250   --host=${CHOST} \   --host=${CHOST} \
251     --build=${CHOST} \
252   --mandir=/usr/share/man \   --mandir=/usr/share/man \
253   --infodir=/usr/share/info \   --infodir=/usr/share/info \
254   --datadir=/usr/share \   --datadir=/usr/share \
255   --sysconfdir=/etc \   --sysconfdir=/etc \
256   --localstatedir=/var/lib \   --localstatedir=/var/lib \
257   --libdir=/usr/$(mlibdir) \   --libdir=/usr/$(mlibdir) \
258     ${myopts} \
259   "$@" || die "mconfigure failed"   "$@" || die "mconfigure failed"
260   else   else
261   echo "configure is not an executable ..."   echo "configure is not an executable ..."
# Line 318  munpack() Line 293  munpack()
293    
294   SRCFILE=$1   SRCFILE=$1
295    
296   if [ -z "$2" ]   if [[ -z $2 ]]
297   then   then
298   DEST=${BUILDDIR}   DEST=${BUILDDIR}
299   else   else
300   DEST=$2   DEST=$2
301   fi   fi
302    
303     [[ ! -d ${DEST} ]] && install -d ${DEST}
304    
305   case "${SRCFILE##*.}" in   case "${SRCFILE##*.}" in
306   bz2)   bz2)
307   IFTAR="$(basename $SRCFILE .bz2)"   IFTAR="$(basename $SRCFILE .bz2)"
308   IFTAR="${IFTAR##*.}"   IFTAR="${IFTAR##*.}"
309   if [[ ${IFTAR} = tar ]]   if [[ ${IFTAR} = tar ]]
310   then   then
311   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."
312     else
313     pushd ${DEST} > /dev/null
314     bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."
315     popd > /dev/null
316   fi   fi
317   ;;   ;;
318   gz)   gz)
# Line 339  munpack() Line 320  munpack()
320   IFTAR="${IFTAR##*.}"   IFTAR="${IFTAR##*.}"
321   if [[ ${IFTAR} = tar ]]   if [[ ${IFTAR} = tar ]]
322   then   then
323   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."
324     else
325     pushd ${DEST} > /dev/null
326     zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."
327     popd > /dev/null
328   fi   fi
329   ;;   ;;
330   tbz2)   xz)
331   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   IFTAR="$(basename $SRCFILE .xz)"
332     IFTAR="${IFTAR##*.}"
333     if [[ ${IFTAR} = tar ]]
334     then
335     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
336     else
337     pushd ${DEST} > /dev/null
338     xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
339     popd > /dev/null
340     fi
341     ;;
342     tbz2|mpks|mpk)
343     tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
344   ;;   ;;
345   tgz)   tgz)
346   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
347     ;;
348     txz|mpkzs|mpkz)
349     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
350     ;;
351     rar)
352     unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."
353     ;;
354     zip|xpi|jar)
355     unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
356     ;;
357     rpm)
358     pushd ${DEST} > /dev/null
359     rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
360     tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
361     if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
362     then
363     rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
364     fi
365   ;;   ;;
366   *)   *)
367   die "munpack failed"   die "munpack failed"
# Line 358  mpatch() Line 373  mpatch()
373  {  {
374   local PATCHOPTS   local PATCHOPTS
375   local PATCHFILE   local PATCHFILE
376     local i
377    
378   PATCHOPTS=$1   PATCHOPTS=$1
379   PATCHFILE=$2   PATCHFILE=$2
380    
381     if [[ -z $2 ]]
382     then
383     PATCHFILE=$1
384    
385     ## patch level auto-detection, get patch level
386     for ((i=0; i < 10; i++))
387     do
388     patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null
389     if [[ $? = 0 ]]
390     then
391     PATCHOPTS="-Np${i}"
392     break
393     fi
394     done
395     fi
396    
397   echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"   echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"
398   patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}   patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}
399  }  }
400    
401    mlibtoolize()
402    {
403     local opts="$@"
404     [[ -z ${opts} ]] && opts="--verbose --install --force"
405    
406     libtoolize ${opts} || die "running: mlibtoolize ${opts}"
407    }
408    
409    mautoreconf()
410    {
411     local opts="$@"
412     [[ -z ${opts} ]] && opts="--verbose --install --force"
413    
414     autoreconf ${opts} || die "running: mautoreconf ${opts}"
415    }
416    
417  minstalldocs()  minstalldocs()
418  {  {
419   local docfiles   local docfiles
420     local doc
421   docfiles="$@"   docfiles="$@"
422    
423   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
# Line 377  minstalldocs() Line 425  minstalldocs()
425   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
426   fi   fi
427    
428   for i in ${docfiles}   for doc in ${docfiles}
429   do   do
430   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."   if [ -f ${doc} ]
431   install -m 0644 ${SRCDIR}/${i}.gz \   then
432   ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."   if mqueryfeature "compressdoc"
433     then
434     cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "gzipping +installing ${doc}."
435     chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "fixing permissions of ${doc}."
436     else
437     install -m 0644 ${SRCDIR}/${i} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
438     fi
439     fi
440   done   done
441  }  }
442    
# Line 389  mstriplibs() Line 444  mstriplibs()
444  {  {
445   local stripdir="$@"   local stripdir="$@"
446    
447   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
448   find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
449     find ${stripdir} ! -type d | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
450  }  }
451    
452  mstripbins()  mstripbins()
453  {  {
454   local stripdir="$@"   local stripdir="$@"
455    
456   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
457   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
458     find ${stripdir} ! -type d | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
459    }
460    
461    mstripstatic()
462    {
463     local stripdir="$@"
464    
465     [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
466     [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
467     find ${stripdir} ! -type d | xargs file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
468    }
469    
470    mstriplibtoolarchive()
471    {
472     local stripdir="$@"
473    
474     [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
475     find ${stripdir} ! -type d -name \*.la | xargs | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
476    }
477    
478    mpurgetargets()
479    {
480     local stripdir="$@"
481     local target
482    
483     [[ -z ${stripdir} ]] && stripdir=${BINDIR}
484     # nothing to do in this case
485     [[ -z ${PURGE_TARGETS[*]} ]] && return
486    
487     for target in ${PURGE_TARGETS[*]}
488     do
489     # check if target is a regex pattern without any slashes
490     if [[ ${target} = ${target//\/} ]]
491     then
492     find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
493     else
494     rm -f -- ${target} 2> /dev/null
495     fi
496     done
497    }
498    
499    mcompressdocs()
500    {
501     local bindir="$@"
502    
503     if [ -d ${bindir}/usr/share/man ]
504     then
505     echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
506     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
507     fi
508    
509     if [ -d ${bindir}/usr/share/info ]
510     then
511     echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
512     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
513     fi
514  }  }
515    
516  sminclude()  sminclude()
# Line 420  setup_distcc_environment() Line 532  setup_distcc_environment()
532  {  {
533   if [ -x /usr/bin/distcc ]   if [ -x /usr/bin/distcc ]
534   then   then
535   echo "Using DistCC for compilation ..."   echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"
536   export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"   export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"
537    
538   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"
# Line 435  setup_ccache_environment() Line 547  setup_ccache_environment()
547  {  {
548   if [ -x /usr/bin/ccache ]   if [ -x /usr/bin/ccache ]
549   then   then
550   echo "Using CCache for compilation ..."   echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"
551   export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"
552   fi   fi
553  }  }
554    
   
555  # fixes given dependencies to match a MAGE_TARGET  # fixes given dependencies to match a MAGE_TARGET
556  # fix_mage_deps -target s/depend # <-- note -target !  # fix_mage_deps -target s/depend # <-- note -target !
557  fix_mage_deps()  fix_mage_deps()
# Line 459  fix_mage_deps() Line 570  fix_mage_deps()
570   # fix DEPEND   # fix DEPEND
571   while read sym dep   while read sym dep
572   do   do
573     # ignore empty lines
574     [[ -z ${dep} ]] && continue
575    
576   cat="$(dirname ${dep})"   cat="$(dirname ${dep})"
577   # change if not virtual   # change if not virtual
578   if [[ ${cat} = virtual ]]   if [[ ${cat} = virtual ]]
# Line 511  EOF Line 625  EOF
625  # special tags:  # special tags:
626  #   PKGTYPE               type of pkg  #   PKGTYPE               type of pkg
627  #   INHERITS              which functions get included  #   INHERITS              which functions get included
628  #   SPECIAL_FUNCTIONS     special functions wich should also be added  #   SPECIAL_FUNCTIONS     special functions which should also be added
629  #                         warning: they get killed before the build starts !  #                         warning: they get killed before the build starts !
630    #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent
631    #   SPLIT_PACKAGE_BASE    base package name for splitpackages
632    #                         (only in the resulting magefile}
633  #  #
634  #   MAGE_TREE_DEST        target destination of the generated tree  #   MAGE_TREE_DEST        target destination of the generated tree
635  #   REGEN_MAGE_TREE       set to 'true' to enable this  #   REGEN_MAGE_TREE       set to 'true' to enable this
# Line 523  build_mage_script() Line 640  build_mage_script()
640   local magefile   local magefile
641   local dest   local dest
642   local target   local target
643     local split_pkg_base
644   local sym   local sym
645   local depname   local depname
646    
# Line 530  build_mage_script() Line 648  build_mage_script()
648   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
649    
650   # determinate which suffix this mage file should get, if any   # determinate which suffix this mage file should get, if any
651   [ -n "$1" ] && target="-$1"   [[ $1 = --target ]] && shift && target="-$1"
652    
653     # mark package as splitpackage
654     [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
655    
656   # name of magefile   # name of magefile
657   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
# Line 539  build_mage_script() Line 660  build_mage_script()
660   dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"   dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"
661    
662   # show what we are doing   # show what we are doing
663   echo "Generating Mage file:"   echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"
664   echo "  ${dest}"   echo "${dest}"
665    
666   install -d "$(dirname ${dest})"   install -d "$(dirname ${dest})"
667   # now build the mage file   # now build the mage file
668   > ${dest}   > ${dest}
669    
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.43 2006-07-17 20:44:44 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
670   # pgkname and state   # pgkname and state
671   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}
672   echo "STATE=\"${STATE}\"" >> ${dest}   echo "STATE=\"${STATE}\"" >> ${dest}
  echo >> ${dest}  
673    
674   # description and homepage   # description and homepage
675   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
676   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
  echo >> ${dest}  
677    
678   # special tags and vars   # special tags and vars
679   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}
680    
681   # echo MAGE_TARGETS ## note -target is needed !   # echo MAGE_TARGETS ## note -target is needed !
682   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}
683   echo >> ${dest}  
684     # split package base
685     echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
686    
687   # add special vars   # add special vars
688   if [ -n "${SPECIAL_VARS}" ]   if [ -n "${SPECIAL_VARS}" ]
# Line 576  build_mage_script() Line 693  build_mage_script()
693   # being tricky here :)   # being tricky here :)
694   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
695   done   done
  echo  >> ${dest}  
696   fi   fi
697    
698   # add at least all includes   # add at least all includes
# Line 588  build_mage_script() Line 704  build_mage_script()
704   do   do
705   echo -n " ${i}"  >> ${dest}   echo -n " ${i}"  >> ${dest}
706   done   done
707   echo  >> ${dest}   # a CRLF is needed here!
708     echo >> ${dest}
709   fi   fi
  echo >> ${dest}  
710    
711   # deps and provides   # deps and provides
712   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
  echo >> ${dest}  
713   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
  echo >> ${dest}  
714   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
  echo >> ${dest}  
715    
716   # add special functions   # add special functions
717   if [ -n "${SPECIAL_FUNCTIONS}" ]   if [ -n "${SPECIAL_FUNCTIONS}" ]
# Line 608  build_mage_script() Line 721  build_mage_script()
721   do   do
722   # add to mage (quotes needed !)   # add to mage (quotes needed !)
723   typeset -f "${i}" >> ${dest}   typeset -f "${i}" >> ${dest}
  echo >> ${dest}  
724   # unset to be safe (quotes needed !)   # unset to be safe (quotes needed !)
725   #unset "${i}" <-- later to get every target built   #unset "${i}" <-- later to get every target built
726   done   done
  echo  >> ${dest}  
727   fi   fi
728    
729   # pre|post-install|removes   # pre|post-install|removes
730   typeset -f preinstall >> ${dest}   typeset -f preinstall >> ${dest}
  echo  >> ${dest}  
731   typeset -f postinstall >> ${dest}   typeset -f postinstall >> ${dest}
  echo  >> ${dest}  
732   typeset -f preremove >> ${dest}   typeset -f preremove >> ${dest}
  echo  >> ${dest}  
733   typeset -f postremove >> ${dest}   typeset -f postremove >> ${dest}
  echo  >> ${dest}  
734  }  }
735    
736  regen_mage_tree()  regen_mage_tree()
737  {  {
738   local i   local subpackage
739    
740   # build them only if requested   # build them only if requested
741   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
742   then   then
743   # run it without targets   # run it without targets
744   if [ -z "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
745   then   then
746     # build for each target a mage file
747     # run it with several targets
748   echo   echo
749   build_mage_script   for subpackage in ${MAGE_TARGETS}
750     do
751     build_mage_script --target "${subpackage}"
752     done
753   echo   echo
  else  
754    
755   # build for each target an mage file   # run it for splitpackages
756     elif [[ -n ${SPLIT_PACKAGES} ]]
757     then
758     local split_pkg_base="${PNAME}"
759     # save smage environment
760     split_save_variables
761     # build for each subpackage a mage file
762   # run it with several targets   # run it with several targets
763   for i in ${MAGE_TARGETS}   echo
764     for subpackage in ${SPLIT_PACKAGES}
765   do   do
766   echo   # get the right variables for the split
767   build_mage_script "${i}"   export PNAME="${subpackage}"
768   echo   split_info_${subpackage}
769     # get the preinstall etc
770     split_export_inherits ${subpackage}
771     build_mage_script --split-pkg-base "${split_pkg_base}"
772     # delete split preinstall etc
773     split_delete_inherits ${subpackage}
774     # restore smage environment
775     split_restore_variables
776   done   done
777     echo
778     # unset all saved smage variables
779     split_unset_variables
780    
781     else
782     echo
783     build_mage_script
784     echo
785   fi   fi
786   fi   fi
787    
788   # now unset all uneeded vars to be safe   # now unset all uneeded vars to be safe
789   # unset PKGNAME <-- don't do that; smage needs this var   # unset PKGNAME <-- don't do that; smage needs this var
790   # unset to be safe (quotes needed !)   # unset to be safe (quotes needed !)
791   for i in ${SPECIAL_FUNCTIONS}  # for i in ${SPECIAL_FUNCTIONS}
792   do  # do
793   unset "${i}"  # unset "${i}"
794   done  # done
795   unset SPECIAL_FUNCTIONS   unset SPECIAL_FUNCTIONS
796   for i in ${SPECIAL_VARS}  # for i in ${SPECIAL_VARS}
797   do  # do
798   unset "${i}"  # unset "${i}"
799   done  # done
800   unset SPECIAL_VARS   unset SPECIAL_VARS
801   unset STATE   unset STATE
802   unset DESCRIPTION   unset DESCRIPTION
803   unset HOMEPAGE   unset HOMEPAGE
804   unset PKGTYPE   # unset PKGTYPE <-- don't do that either; smage needs this var
805   unset INHERITS   unset INHERITS
806   unset DEPEND   unset DEPEND
807   unset SDEPEND   unset SDEPEND
# Line 679  regen_mage_tree() Line 812  regen_mage_tree()
812   unset postremove   unset postremove
813  }  }
814    
815    split_save_variables()
816    {
817     export SAVED_PNAME="${PNAME}"
818     export SAVED_PVER="${PVER}"
819     export SAVED_PBUILD="${PBUILD}"
820     export SAVED_PCATEGORIE="${PCATEGORIE}"
821     export SAVED_DESCRIPTION="${DESCRIPTION}"
822     export SAVED_HOMEPAGE="${HOMEPAGE}"
823     export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
824     export SAVED_STATE="${STATE}"
825     export SAVED_PKGTYPE="${PKGTYPE}"
826     export SAVED_INHERITS="${INHERITS}"
827     export SAVED_DEPEND="${DEPEND}"
828     export SAVED_SDEPEND="${SDEPEND}"
829     export SAVED_PROVIDE="${PROVIDE}"
830     export SAVED_PKGTYPE="${PKGTYPE}"
831    
832     # special handling needed for mage features
833     # pkgbuild
834     mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
835     mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
836     # strip
837     mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
838     mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
839     # libtool
840     mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
841     mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
842     # compressdoc
843     mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
844     mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
845    
846     # bindir too
847     export SAVED_BINDIR="${BINDIR}"
848    
849     # export the SPLIT_PACKAGE_BASE
850     export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
851    
852     # functions
853     if [[ ! -z $(typeset -f preinstall) ]]
854     then
855     # rename the old one
856     local saved_preinstall
857     saved_preinstall=SAVED_$(typeset -f preinstall)
858     eval "${saved_preinstall}"
859     export -f SAVED_preinstall
860     fi
861    
862     if [[ ! -z $(typeset -f postinstall) ]]
863     then
864     # rename the old one
865     local saved_postinstall
866     saved_postinstall=SAVED_$(typeset -f postinstall)
867     eval "${saved_postinstall}"
868     export -f SAVED_postinstall
869     fi
870    
871     if [[ ! -z $(typeset -f preremove) ]]
872     then
873     # rename the old one
874     local saved_preremove
875     saved_preremove=SAVED_$(typeset -f preremove)
876     eval "${saved_preremove}"
877     export -f SAVED_preremove
878     fi
879    
880     if [[ ! -z $(typeset -f postremove) ]]
881     then
882     # rename the old one
883     local saved_postremove
884     saved_postremove=SAVED_$(typeset -f postremove)
885     eval "${saved_postremove}"
886     export -f SAVED_postremove
887     fi
888    }
889    
890    split_restore_variables()
891    {
892     export PNAME="${SAVED_PNAME}"
893     export PVER="${SAVED_PVER}"
894     export PBUILD="${SAVED_PBUILD}"
895     export PCATEGORIE="${SAVED_PCATEGORIE}"
896     export DESCRIPTION="${SAVED_DESCRIPTION}"
897     export HOMEPAGE="${SAVED_HOMEPAGE}"
898     export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
899     export STATE="${SAVED_STATE}"
900     export PKGTYPE="${SAVED_PKGTYPE}"
901     export INHERITS="${SAVED_INHERITS}"
902     export DEPEND="${SAVED_DEPEND}"
903     export SDEPEND="${SAVED_SDEPEND}"
904     export PROVIDE="${SAVED_PROVIDE}"
905     export PKGTYPE="${SAVED_PKGTYPE}"
906    
907     # special handling needed for mage features
908     # pkgbuild
909     FVERBOSE=off msetfeature "${SAVED_FEATURE_PKGBUILD}"
910     # strip
911     FVERBOSE=off msetfeature "${SAVED_FEATURE_STRIP}"
912     # libtool
913     FVERBOSE=off msetfeature "${SAVED_FEATURE_LIBTOOL}"
914     # compressdoc
915     FVERBOSE=off msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
916    
917     # bindir too
918     export BINDIR="${SAVED_BINDIR}"
919    
920     # functions
921     if [[ ! -z $(typeset -f SAVED_preinstall) ]]
922     then
923     # rename the old one
924     local saved_preinstall
925     saved_preinstall=$(typeset -f SAVED_preinstall)
926     eval "${saved_preinstall/SAVED_/}"
927     export -f preinstall
928     fi
929    
930     if [[ ! -z $(typeset -f SAVED_postinstall) ]]
931     then
932     # rename the old one
933     local saved_postinstall
934     saved_postinstall=$(typeset -f SAVED_postinstall)
935     eval "${saved_postinstall/SAVED_/}"
936     export -f postinstall
937     fi
938    
939     if [[ ! -z $(typeset -f SAVED_preremove) ]]
940     then
941     # rename the old one
942     local saved_preremove
943     saved_preremove=$(typeset -f SAVED_preremove)
944     eval "${saved_preremove/SAVED_/}"
945     export -f preremove
946     fi
947    
948     if [[ ! -z $(typeset -f SAVED_postremove) ]]
949     then
950     # rename the old one
951     local saved_postremove
952     saved_postremove=$(typeset -f SAVED_postremove)
953     eval "${saved_postremove/SAVED_/}"
954     export -f postremove
955     fi
956    }
957    
958    split_unset_variables()
959    {
960     # unset saved vars; not needed anymore
961     unset SAVED_PNAME
962     unset SAVED_PVER
963     unset SAVED_PBUILD
964     unset SAVED_PCATEGORIE
965     unset SAVED_DESCRIPTION
966     unset SAVED_HOMEPAGE
967     unset SAVED_SPECIAL_VARS
968     unset SAVED_STATE
969     unset SAVED_PKGTYPE
970     unset SAVED_INHERITS
971     unset SAVED_DEPEND
972     unset SAVED_SDEPEND
973     unset SAVED_PROVIDE
974     unset SAVED_BINDIR
975     unset SAVED_PKGTYPE
976     unset SAVED_FEATURE_PKGBUILD
977     unset SAVED_FEATURE_STRIP
978     unset SAVED_FEATURE_LIBTOOL
979     unset SAVED_FEATURE_COMPRESSDOC
980     unset SPLIT_PACKAGE_BASE
981     unset -f SAVED_preinstall
982     unset -f SAVED_postinstall
983     unset -f SAVED_preremove
984     unset -f SAVED_postremove
985    }
986    
987    split_export_inherits()
988    {
989     local subpackage="$1"
990     local func
991     local newfunc
992    
993     for func in preinstall postinstall preremove postremove
994     do
995     if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
996     then
997     newfunc=$(typeset -f ${func}_${subpackage})
998     newfunc="${newfunc/_${subpackage} (/ (}"
999     eval "${newfunc}"
1000     fi
1001     done
1002    }
1003    
1004    split_delete_inherits()
1005    {
1006     local subpackage="$1"
1007     local func
1008    
1009     for func in preinstall postinstall preremove postremove
1010     do
1011     if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1012     then
1013     unset -f ${func}
1014     fi
1015     done
1016     }
1017    
1018  export_inherits()  export_inherits()
1019  {  {
1020   local include="$1"   local include="$1"
# Line 744  generate_package_md5sum() Line 1080  generate_package_md5sum()
1080   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"
1081    
1082   # build pkg-md5-sum only if requested   # build pkg-md5-sum only if requested
1083   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
1084   then   then
1085   echo -n "Generating a md5sum for ${pkgname}.${PKGSUFFIX} ... "   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1086    
1087   # abort if not exist   # abort if not exist
1088   if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]   if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]
1089   then   then
1090   echo "! exists"   echo -e "${COLRED}! exists${COLDEFAULT}"
1091   return 0   return 0
1092   fi   fi
1093    
# Line 759  generate_package_md5sum() Line 1095  generate_package_md5sum()
1095   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1096    
1097   # setup md5 dir   # setup md5 dir
1098   dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"   dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"
1099   install -d ${dest}   install -d ${dest}
1100    
1101   # gen md5sum   # gen md5sum
1102   ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \   ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \
1103   > ${dest}/${pkgname}.md5   > ${dest}/${pkgname}.md5
1104   echo "done"   echo -e "${COLGREEN}done${COLDEFAULT}"
1105   fi   fi
1106  }  }
1107    
1108    source_pkg_build()
1109    {
1110     if [[ ${PKGTYPE} = virtual ]]
1111     then
1112     echo "Virtual package detected; src-pkg-tarball not necessary ..."
1113     return 0
1114     fi
1115    
1116     if [[ ! -d ${SOURCEDIR}/${PNAME} ]]
1117     then
1118     echo "No SRC_URI defined; src-pkg-tarball not necessary ..."
1119     return 0
1120     fi
1121    
1122     [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."
1123    
1124     echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"
1125    
1126     # include the smage2 file
1127     cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}
1128    
1129     ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )
1130     [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}
1131     mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}
1132    
1133     echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"
1134    }
1135    
1136    step_by_step()
1137    {
1138     if mqueryfeature stepbystep
1139     then
1140     echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1141     echo "Press [enter] to continue"
1142     read
1143     fi
1144    }
1145    
1146    
1147  # print out our version  # print out our version
1148  showversion  showversion
1149  echo  echo
# Line 780  then Line 1155  then
1155   exit 1   exit 1
1156  fi  fi
1157    
1158    # load supported mage features
1159    load_mage_features
1160    
1161  # updating smage2-scripts  # updating smage2-scripts
1162  if [[ $1 = update ]]  if [[ $1 = update ]]
1163  then  then
# Line 794  fi Line 1172  fi
1172  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
1173  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
1174  then  then
1175   if [ $# -ge 3 ]   if [ $# -ge 2 ]
1176   then   then
1177   SMAGENAME="$2"   SMAGENAME="$2"
1178   MD5DIR="$3"   MD5DIR="$3"
1179   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
1180    
1181     smagesource ${SMAGENAME} || die "download source failed"
1182    
1183   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
1184   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 850  then Line 1230  then
1230   echo   echo
1231   else   else
1232   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
1233   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
1234   echo   echo
1235   echo   echo
1236   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 872  then Line 1252  then
1252   # get smage   # get smage
1253   SMAGENAME="$2"   SMAGENAME="$2"
1254   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1255   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
1256    
1257   download_sources   download_sources
1258   exit 0   exit 0
# Line 884  then Line 1264  then
1264   # set correct SMAGENAME   # set correct SMAGENAME
1265   SMAGENAME="$2"   SMAGENAME="$2"
1266   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1267   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1268    
1269   regen_mage_tree   regen_mage_tree
1270    
1271   # build md5sum for existing packages   # build several targets
1272   generate_package_md5sum \   if [[ -n ${MAGE_TARGETS} ]]
1273   --pcat "${PCATEGORIE}" \   then
1274   --pname "${PNAME}" \   for target in ${MAGE_TARGETS}
1275   --pver "${PVER}" \   do
1276   --pbuild "${PBUILD}" \   # build md5sum for existing packages
1277   --parch "${ARCH}" \   generate_package_md5sum \
1278   --target "${target}"   --pcat "${PCATEGORIE}" \
1279     --pname "${PNAME}" \
1280     --pver "${PVER}" \
1281     --pbuild "${PBUILD}" \
1282     --parch "${ARCH}" \
1283     --target "${target}"
1284     done
1285    
1286     # build several subpackages
1287     elif [[ -n ${SPLIT_PACKAGES} ]]
1288     then
1289     split_save_variables
1290     for subpackage in ${SPLIT_PACKAGES}
1291     do
1292     # get the right variables for the split
1293     export PNAME="${subpackage}"
1294     split_info_${subpackage}
1295     # build md5sum for existing packages
1296     generate_package_md5sum \
1297     --pcat "${PCATEGORIE}" \
1298     --pname "${PNAME}" \
1299     --pver "${PVER}" \
1300     --pbuild "${PBUILD}" \
1301     --parch "${ARCH}"
1302     # restore smage environment
1303     split_restore_variables
1304     done
1305     # unset all saved smage variables
1306     split_unset_variables
1307    
1308     else
1309     # build md5sum for existing packages
1310     generate_package_md5sum \
1311     --pcat "${PCATEGORIE}" \
1312     --pname "${PNAME}" \
1313     --pver "${PVER}" \
1314     --pbuild "${PBUILD}" \
1315     --parch "${ARCH}"
1316     fi
1317    
1318   exit 0   exit 0
1319  fi  fi
1320    
1321    if [ "$1" == "--create-src-tarball" -a -n "$2" ]
1322    then
1323     # set correct SMAGENAME
1324     SMAGENAME="$2"
1325     MD5DIR="$(dirname ${SMAGENAME})/md5"
1326    
1327     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
1328    
1329     smagesource ${SMAGENAME} || die "regen: smage2 not found"
1330    
1331     if [[ -d ${SOURCEDIR}/${PNAME} ]]
1332     then
1333     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
1334     rm -rf ${SOURCEDIR}/${PKGNAME}
1335     fi
1336    
1337     download_sources
1338     source_pkg_build ${SMAGENAME}
1339     exit 0
1340    fi
1341    
1342    if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
1343    then
1344     SRCPKGTARBALL="${2}"
1345     msetfeature "srcpkgtarball"
1346    
1347     # abort if given file is not a source pkg
1348     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
1349    
1350     # set correct SMAGENAME; use the one that the src_pkg provide
1351     # /path/to/SOURCEDIR/PNAME/SMAGENAME
1352     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
1353    
1354     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
1355    
1356     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
1357    
1358     # unpack srctarball
1359     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
1360    
1361     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
1362    
1363     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
1364    fi
1365    
1366    
1367  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
1368  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
1369   die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."   die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
1370  [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your mage.rc correctly."  [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
1371  [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."  [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
1372  [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
1373  [ -z "${BINDIR}" ] && die "no BINDIR variable found in /etc/mage.rc"  [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
1374  [ -z "${CHOST}" ] && die "no CHOST variable found in /etc/mage.rc"  [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
1375  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in /etc/mage.rc"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
1376  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in /etc/mage.rc"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
1377    
1378  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
1379  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"
1380  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
1381    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
1382    
1383  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
1384  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
1385    
1386  # auto regen mage tree if requested  # auto regen mage tree if requested
1387  regen_mage_tree  regen_mage_tree
1388    
1389    if mqueryfeature "srcpkg"
1390    then
1391     if [[ -d ${SOURCEDIR}/${PNAME} ]]
1392     then
1393     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
1394     rm -rf ${SOURCEDIR}/${PNAME}
1395     fi
1396    fi
1397    
1398  # download sources  # download sources
1399  download_sources  mqueryfeature "srcpkgtarball" || download_sources
1400    
1401  # fixes some issues with these functions  # fixes some issues with these functions
1402  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
1403  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
1404    export -f src_check || die "src_check export failed"
1405  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
1406    
1407  # fixes some compile issues  # fixes some compile issues
1408  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
1409  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
1410  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
1411    then
1412     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
1413    else
1414     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
1415    fi
1416    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
1417  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
1418  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
1419    
   
1420  # setup distcc  # setup distcc
1421  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
1422  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
1423    
1424  # setup ccache  # setup ccache
1425  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
   
 # small sleep to show our settings  
 sleep 1  
1426    
1427  # cleans up build if a previously one exists  # clean up builddir if a previously one exist
1428  if [ -d ${BUILDDIR} ]  if [ -d ${BUILDDIR} ]
1429  then  then
1430   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
1431  fi  fi
1432  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
1433    
1434  # cleans up srcdir if a previously unpacked one exists  # clean up srcdir if a previously unpacked one exist
1435  if [ -d ${SRCDIR} ]  if [ -d ${SRCDIR} ]
1436  then  then
1437   rm -rf ${SRCDIR}   rm -rf ${SRCDIR}
1438  fi  fi
1439    
1440  # cleans up bindir if a previous build exists or creates a new one  # clean up bindir if a previous build exist or create a new one
1441  if [ -d ${BINDIR} ]  if [ -d ${BINDIR} ]
1442  then  then
1443   rm -rf ${BINDIR}   rm -rf ${BINDIR}
1444  fi  fi
1445  install -d ${BINDIR} || die "couldn't create \$BINDIR."  install -d ${BINDIR} || die "couldn't create \$BINDIR."
1446    
1447  # cleans up package temp dir if a previous build exists  # clean up package temp dir if a previous build exist
1448  if [ -d ${BUILDDIR}/${PKGNAME} ]  if [ -d ${BUILDDIR}/${PKGNAME} ]
1449  then  then
1450   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${BUILDDIR}/${PKGNAME}
1451  fi  fi
1452    
1453  # cleans up timestamp if one exists  # setup build logging
1454  if [ -f /var/tmp/timestamp ]  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1455    echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1456    
1457    if [[ ${PKGTYPE} = virtual ]]
1458  then  then
1459   mage rmstamp   echo "virtual package detected; nothing will be build ..."
1460     # automatically set !pkgbuild here too
1461     msetfeature "!pkgbuild"
1462    else
1463     src_prepare | ${SMAGE_LOG_CMD}
1464     die_pipestatus 0 "src_prepare failed"
1465     step_by_step $_
1466    
1467     src_compile | ${SMAGE_LOG_CMD}
1468     die_pipestatus 0 "src_compile failed"
1469     step_by_step $_
1470    
1471     # only run checks if requested
1472     if mqueryfeature "!check"
1473     then
1474     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
1475     step_by_step src_check
1476     else
1477     src_check | ${SMAGE_LOG_CMD}
1478     die_pipestatus 0 "src_check failed"
1479     step_by_step $_
1480     fi
1481    
1482     # build several subpackages
1483     if [[ -n ${SPLIT_PACKAGES} ]]
1484     then
1485     # save bindir & pname
1486     split_save_variables
1487     export SAVED_BINDIR="${BINDIR}"
1488     for subpackage in ${SPLIT_PACKAGES}
1489     do
1490     if typeset -f src_install_${subpackage} > /dev/null
1491     then
1492     # export subpackage bindir
1493     export BINDIR="${SAVED_BINDIR}_${subpackage}"
1494     # export PNAME, several internal function and include
1495     # rely on this variable
1496     export PNAME="${subpackage}"
1497    
1498     echo
1499     echo -en "${COLBLUE}*** ${COLDEFAULT}"
1500     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
1501     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
1502     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
1503    
1504     src_install_${subpackage} | ${SMAGE_LOG_CMD}
1505     die_pipestatus 0 "src_install_${subpackage} failed"
1506     step_by_step $_
1507     fi
1508     done
1509     # restore bindir & pname
1510     split_restore_variables
1511     # unset all saved smage variables
1512     split_unset_variables
1513     else
1514     src_install | ${SMAGE_LOG_CMD}
1515     die_pipestatus 0 "src_install failed"
1516     step_by_step $_
1517     fi
1518  fi  fi
1519    
1520  src_prepare || die "src_prepare failed"  # echo for sake of good-looking
1521  src_compile || die "src_compile failed"  echo
 src_install || die "src_install failed"  
1522    
1523    if mqueryfeature "!compressdoc"
1524    then
1525     echo -e "!compressdoc detected; documentation will not be compressed ..."
1526    elif mqueryfeature "!pkgbuild"
1527    then
1528     echo "!pkgbuild detected; skipping documentation compression..."
1529    else
1530     # compressing doc, info & man files
1531     if [[ -n ${SPLIT_PACKAGES} ]]
1532     then
1533     for subpackage in ${SPLIT_PACKAGES}
1534     do
1535     mcompressdocs ${BINDIR}_${subpackage}
1536     done
1537     else
1538     mcompressdocs ${BINDIR}
1539     fi
1540    fi
1541    
1542  # compressing doc, info & man files  if mqueryfeature "!libtool"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
1543  then  then
1544   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   if mqueryfeature "!pkgbuild"
1545     then
1546     echo "!pkgbuild detected; skipping libtool archive stripping ..."
1547     else
1548     if [[ -n ${SPLIT_PACKAGES} ]]
1549     then
1550     for subpackage in ${SPLIT_PACKAGES}
1551     do
1552     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
1553     mstriplibtoolarchive ${BINDIR}_${subpackage}
1554     done
1555     else
1556     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
1557     mstriplibtoolarchive ${BINDIR}
1558     fi
1559     fi
1560  fi  fi
1561    
1562  echo -e "Compressing info-pages ..."  if mqueryfeature "purge"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
1563  then  then
1564   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   if mqueryfeature "!pkgbuild"
1565     then
1566     echo "!pkgbuild detected; skipping file purgation..."
1567     else
1568     if [[ -n ${SPLIT_PACKAGES} ]]
1569     then
1570     for subpackage in ${SPLIT_PACKAGES}
1571     do
1572     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
1573     mpurgetargets ${BINDIR}_${subpackage}
1574     done
1575     else
1576     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
1577     mpurgetargets ${BINDIR}
1578     fi
1579     fi
1580  fi  fi
1581    
1582  # stripping all bins and libs  # stripping all bins and libs
1583  case ${NOSTRIP} in  if mqueryfeature "!strip"
1584   true|TRUE|yes|y)  then
1585   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "!strip detected; Package will not be stripped ..."
1586   ;;  elif mqueryfeature "!pkgbuild"
1587   *)  then
1588   echo -e "Stripping binaries ..."   echo "!pkgbuild detected; skipping stripping of the package ..."
1589   mstripbins ${BINDIR}  else
1590   echo -e "Stripping libraries ..."   if [[ -n ${SPLIT_PACKAGES} ]]
1591   mstriplibs ${BINDIR}   then
1592   ;;   for subpackage in ${SPLIT_PACKAGES}
1593  esac   do
1594     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
1595  # the new buildpkg command   mstripbins ${BINDIR}_${subpackage}
1596  case ${NOPKGBUILD} in   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
1597   true|TRUE|yes|y)   mstriplibs ${BINDIR}_${subpackage}
1598   echo -e "NOPGKBUILD=true detected; Package will not be build ..."   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
1599   ;;   mstripstatic ${BINDIR}_${subpackage}
1600   *)   done
1601     else
1602     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
1603     mstripbins ${BINDIR}
1604     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
1605     mstriplibs ${BINDIR}
1606     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
1607     mstripstatic ${BINDIR}
1608     fi
1609    fi
1610    
1611    if mqueryfeature "!pkgbuild"
1612    then
1613     echo -e "!pkgbuild detected; Package will not be build ..."
1614    else
1615   # build several targets   # build several targets
1616   if [ -n "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
1617   then   then
1618   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1619   do   do
1620   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
1621   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
1622   then   then
1623   # run it   # run it
# Line 1041  case ${NOPKGBUILD} in Line 1637  case ${NOPKGBUILD} in
1637   --parch "${ARCH}" \   --parch "${ARCH}" \
1638   --target "${target}"   --target "${target}"
1639    
1640   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1641   done   done
1642    
1643     # build several subpackages
1644     elif [[ -n ${SPLIT_PACKAGES} ]]
1645     then
1646     split_save_variables
1647     for subpackage in ${SPLIT_PACKAGES}
1648     do
1649     # get the right variables for the split
1650     export PNAME="${subpackage}"
1651     split_info_${PNAME}
1652    
1653     # jump to next one if !pkgbuild is set in split_info
1654     mqueryfeature "!pkgbuild" && continue
1655    
1656     # check if an special subpackage_pkgbuild exists
1657     if typeset -f ${PNAME}_pkgbuild > /dev/null
1658     then
1659     # run it
1660     ${PNAME}_pkgbuild
1661     fi
1662     # now create the target package
1663     ${MLIBDIR}/pkgbuild_dir.sh \
1664     "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \
1665     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
1666    
1667     # build pkg-md5-sum if requested
1668     generate_package_md5sum \
1669     --pcat "${PCATEGORIE}" \
1670     --pname "${PNAME}" \
1671     --pver "${PVER}" \
1672     --pbuild "${PBUILD}" \
1673     --parch "${ARCH}"
1674    
1675     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1676    
1677     # restore smage environment
1678     split_restore_variables
1679     done
1680     # unset all saved smage variables
1681     split_unset_variables
1682    
1683   else   else
1684   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
1685    
# Line 1054  case ${NOPKGBUILD} in Line 1691  case ${NOPKGBUILD} in
1691   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
1692   --parch "${ARCH}"   --parch "${ARCH}"
1693    
1694   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
1695   fi   fi
  ;;  
 esac  
1696    
1697  # for sure   # build src-pkg-tarball if requested
1698  unset NOPKGBUILD   mqueryfeature "srcpkg" && source_pkg_build ${SMAGENAME}
1699  unset NOSTRIP  fi
1700    
1701    if mqueryfeature "buildlog"
1702    then
1703     bzip2 -9f /var/log/smage/${PKGNAME}.log
1704    else
1705     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
1706    fi
1707    
1708  xtitleclean  xtitleclean

Legend:
Removed from v.384  
changed lines
  Added in v.1616